<?php

use think\migration\Migrator;

class CreateSysBanner extends Migrator
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-abstractmigration-class
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function change()
    {
        $table = $this->table('sys_banner', ['engine' => 'InnoDB', 'comment' => '系统Banner表']);
        $table->addColumn('language_id', 'integer', ['null' => false, 'comment' => '语言ID'])
            ->addColumn('at_platform', 'string', ['limit' => 8, 'null' => false, 'comment' => '所在平台: pc为电脑, mobile为手机'])
            ->addColumn('at_page', 'string', ['limit' => 255, 'null' => true, 'comment' => '所在页面'])
            ->addColumn('unique_label', 'string', ['limit' => 64, 'null' => false, 'comment' => 'banner唯一标识'])
            ->addColumn('name', 'string', ['limit' => 64, 'null' => false, 'comment' => 'banner名称'])
            ->addColumn('desc', 'string', ['limit' => 255, 'null' => false, 'default' => '', 'comment' => 'banner描述'])
            ->addColumn('sort', 'integer', ['limit' => 11, 'null' => false, 'default' => 0, 'comment' => '排序'])
            ->addColumn('recommend', 'boolean', ['limit' => 1, 'null' => false, 'default' => 0, 'comment' => '是否推荐: 1为是, 0为否'])
            ->addColumn('status', 'boolean', ['limit' => 1, 'null' => false, 'default' => 1, 'comment' => '-1为禁用, 1为启用'])
            ->addColumn('created_at', 'timestamp', ['null' => false, 'default' =>'CURRENT_TIMESTAMP', 'comment' => '创建时间'])
            ->addColumn('updated_at', 'timestamp', ['null' => false, 'default' =>'CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP', 'comment' => '更新时间'])
            ->addColumn('deleted_at', 'timestamp', ['null' => true, 'default' => null, 'comment' => '删除时间'])
            ->addIndex(['at_platform', 'language_id', 'unique_label'], ['name' => 'idx_at_platform_language_id_unique_label', 'unique' => true])
            ->create();
    }
}
